<template>
  <single-panel
    :capt="order.number"
    :backlink="backLink"
  >
    <ObForm
      class='order-card'
      :class="isClicar && !isSubOrder && '--is-clicar'"
      :is-loading="isLoading"
      :is-show-controls="false"
      :form-data="order"
    >
      <LeftSide v-if="isClicar && !isSubOrder" />
      <div class="order-card__right">
        <div
          v-for="(item, index) in ordersList"
          :key="item.uuid"
          :class="{
            '--collapsed': index === 0 && selectedSubOrder
          }"
        >
          <transition name="slideOrder">
            <CardBody
              ref="rightBlock"
              v-if="showBody(item)"
              :uuid="item.uuid"
            />
          </transition>
        </div>
      </div>
      <RightSide
        v-if="isClient || isCarrier || isSubOrder"
        :order="order"
      />
      <transition name="slideLeft">
        <LotHistory v-if="isVisibleLotHistoryComputed"/>
      </transition>
      <transition name="slideLeft">
        <OrderAdvancePanel
          v-if="isVisibleAdvance"
          :order="order"
        />
      </transition>
    </ObForm>
  </single-panel>
</template>
<script>
  import { mapActions, mapGetters, mapMutations } from 'vuex'
  import singlePanel from 'common-components/src/obComponents/obSinglePanels'
  import ObForm from 'common-components/src/obComponents/obForm'

  import LeftSide from '@/components/Order/orderItem/LeftSide'
  import RightSide from '@/components/Order/orderItem/RightSide'
  import CardBody from '@/components/Order/orderItem/CardBody'
  import LotHistory from '@/components/Order/orderItem/LotHistory'
  import OrderAdvancePanel from '@/components/Order/orderItem/advance/panel'

  export default {
    name: 'order-card',

    components: {
      singlePanel,
      LeftSide,
      RightSide,
      CardBody,
      ObForm,
      LotHistory,
      OrderAdvancePanel
    },
    data () {
      return {
        isRole: 'client'
      }
    },
    created () {
      this.setRoute(this.$route)
      this.$nextTick(() => {
        this.getOrderData({
          uuid: this.$route.params.id,
          getSubOrder: !this.isClient,
          init: true
        })
      })
    },
    beforeDestroy () {
      this.clearOrderState()
    },
    watch: {
      $route: {
        immediate: true,
        handler (val) {
          if (val) {
            this.setRoute(val)
          }
        }
      }
    },
    computed: {
      ...mapGetters({
        isClicar: 'user/isClicar',
        isClient: 'user/isClient',
        isCarrier: 'user/isCarrier',
        order: 'order/order',
        subOrders: 'order/subOrders',
        subOrder: 'order/subOrder',
        selectedSubOrder: 'order/selectedSubOrder',
        selectedTrip: 'order/selectedTrip',
        isLoading: 'order/isLoading',
        isVisibleLotHistory: 'order/isVisibleLotHistory',
        isVisibleAdvance: 'order/isVisibleAdvance',
        historyPage: 'user/historyPage'
      }),
      ordersList () {
        return [
          { uuid: this.orderId },
          ...this.subOrders
        ]
      },
      orderId () {
        return this.$route.params.id
      },
      isVisibleLotHistoryComputed () {
        const order = this.isSubOrder ? this.order : this.selectedSubOrder || {}
        return this.isVisibleLotHistory && (order.species === 'AUTO' || order.subOrderType === 'AUTO')
      },
      isSubOrder () {
        return this.$route.query.is_suborder
      },
      backLink () {
        const route = JSON.parse(sessionStorage.getItem('route'));
        if (this.isCarrier) {
          return {
            name: 'requests__executed-orders'
          }
        } else if (route !== null) {
          return {
            name: route.name,
            query: route.query
          }
        } else {
          return {
            name: 'order__performerer'
          }
        }
      }
    },
    methods: {
      ...mapActions({
        getOrderData: 'order/getOrder',
        clearOrderState: 'order/clearState'
      }),
      ...mapMutations({
        setRoute: 'order/setRoute'
      }),
      showBody (data) {
        return (this.selectedSubOrder && this.selectedSubOrder.uuid === data.uuid && this.selectedSubOrder.species === data.species) || data.uuid === this.orderId
      }
    }
  }
</script>
<style lang="scss" scoped>
  @import '~common-components/src/static/css/variables';
  @import '~common-components/src/static/css/mixins';

  .order-card {
    position: relative;
    overflow: auto;
    height: 100%;
    display: flex;
    justify-content: space-between;
    background-color: $background-white;

    &::v-deep {
      .form-body {
        display: flex;
        justify-content: space-between;
        width: 100%;
      }

      .loading-block {
        align-items: flex-start;
        padding-top: 25vh;
      }

      .table-panel-inner {
        z-index: 1;
      }
    }

    &__right {
      position: relative;
      z-index: 10;
      flex-grow: 2;
      display: flex;
      flex-direction: column;
      &::v-deep {
        & > div {
          display: flex;
          width: 100%;
          &:empty {
            width: 0;
          }
          &:not(:empty) {
            flex-grow: 2;
            height: 100%;
          }
          &.--collapsed {
            flex-grow: initial;
          }
        }
      }
    }

    &.--is-clicar {
      .order-card__right {
        &::v-deep {
          .order-card-body__nav {
            width: 100%;
          }

          & > div:not(:empty) {
            height: auto;
          }
        }
      }
    }

    &::v-deep {
      .ob-order-contractor-card {
        padding: 0;
      }

      .ob-order-contractor-card__caption {
        margin-bottom: 35px;
      }

      .ob-order-route-card .card-title {
        display: none;
      }

      .ob-order-route-card .card-list {
        margin-top: 25px;
        margin-right: 21px;
      }
    }

    .slideOrder-leave-to, .slideOrder-enter {
      position: absolute;
      top: 100px;
      opacity: 0;
      transform: translateY(100px);
    }

    .slideOrder-enter-active, .slideOrder-leave-active {
      transition: opacity .4s ease-out, transform .4s ease-out, top .4s ease-out;
    }

    .slideLeft-leave-to {
      opacity: 0;
    }

    .slideLeft-enter {
      opacity: 0;
      transform: translateX(40px);
    }

    .slideLeft-enter-active {
      transition: opacity .3s ease-out, transform .3s ease-out;
    }
    .slideLeft-leave-active {
      transition: opacity .2s ease-out;
    }
  }
</style>
<style lang="scss">
  .order-card {
    .not-api {
      box-shadow: 0 0 5px $orderPage-item_card_not_api;
    }
  }
</style>

